Subject: Re: [PATCH v2 04/13] gnu: Add Zuo.

From: "Philip McGrath" <[email-masked]>
Date: Thu, 11 Aug 2022 19:32:34 -0400

Hi,

On Thu, Aug 11, 2022, at 11:34 AM, Liliana Marie Prikler wrote:
> Am Donnerstag, dem 11.08.2022 um 10:00 -0400 schrieb Philip McGrath:
>> I'm planning to respond in the other thread about the possibility of
>> a truly generic macro name, but I hope it doesn't need to become an
>> issue blocking this patch series. For now, I'm not entirely sure what
>> "Racket-agnostic" means; the bottom line for my is I think it would
>> be absurdly awful to have to write, e.g. if cross-compiling using
>> `distro-build` with the top-level Makefile:
>> 
>>     ./configure CPPFLAGS="GUIX_RKTIO_BIN_SH=/input/bin/sh
>> GUIX_ZUO_BIN_SH=/input/bin/sh GUIX_CHEZ_BIN_SH=/input/bin/sh"
>> CPPFLAGS_FOR_BUILD="GUIX_RKTIO_BIN_SH=/native-input/bin/sh
>> GUIX_ZUO_BIN_SH=/native-input/bin/sh GUIX_CHEZ_BIN_SH=/native-
>> input/bin/sh"
> GUIX_CHEZ_BIN_SH would semantically cover all four however, no? 
> (Ignoring more generic options for now.)
>

I don't think so. Zuo and Racket BC have at least as little to do with Chez as upstream Chez has to do with rktio.

>> > > +      (home-page "https://github.com/racket/zuo")
>> > > +      ;; ^ This is downstream of
>> > > https://github.com/racket/racket,
>> > > +      ;; but it's designed to be a friendly landing place
>> > > +      (synopsis "Tiny Racket for build scripts")
>> > > +      (description "You should use Racket to write scripts.
>> > Sorry, but I prefer Guile.
>> 
>> (At the risk of responding seriously to what was probably meant to be
>> a joke:) I've never tried to use Guile on Windows, but, given that
>> the manual chapter is called "POSIX System Calls and Networking",
>> it's not clear to me that Guile provides as portable and powerful
>> "primitives for dealing with files and running processes" as Zuo, let
>> alone Racket.
> At the risk of responding seriously to what was probably meant to be a
> joke, I don't use Winblows 😉️
>

If you want to be horrified, read <https://docs.racket-lang.org/reference/windowspaths.html>. I'm very glad Racket manages all that complexity for me. (And in fairness, even on Unix, there are valid paths which can not be represented as Scheme strings.)

-Philip